/***************************************************************************
                          preffrontenddlg.h  -  description
                             -------------------
    begin                : Fri Jun 13 2003
    copyright            : (C) 2003 by Elad Lahav
    email                : elad_lahav@users.sf.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PREFFRONTENDDLG_H
#define PREFFRONTENDDLG_H

#include <qwidget.h>
#include <preffrontendlayout.h>

/**
 * A widget for setting the paths to various programmes to which KScope
 * provides a front-end.
 * @author Elad Lahav
 */

class PrefFrontend : public PrefFrontendLayout
{
   Q_OBJECT

public: 
	PrefFrontend(QWidget* pParent = 0, const char* szName = 0);
	~PrefFrontend();

	void load();
	void apply();
	
signals:
	/**
	 * Emitted whenever the user makes a change to the dialogue's input 
	 * widgets.
	 */
	void modified();
	
private slots:
	void slotFindCscope();
	void slotFindCtags();
	void slotChanged(const QString&);
	void slotGuessPaths();
};

#endif
